/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package controls;

import java.awt.*;
import javax.swing.*;

/**
 *
 * @author stefano
 */
public class GradientPane extends JPanel {

    private Color c1;
    private Color c2;
    private String title = null;
    private Icon icon = null;
    
    private int indent = 0;
    private Color highlight = new Color(218, 218, 218);
    public GradientPane() {
        c1 = new Color(218, 218, 218);
        c2 = new Color(190, 190, 190);
        setBorder(BorderFactory.createCompoundBorder(BorderFactory.createMatteBorder(1, 0, 0, 0, Color.WHITE), 
                BorderFactory.createMatteBorder(0, 0, 1, 0, new Color(85, 85, 85))));
        
    };
    
    public GradientPane(Color c1, Color c2) {
        this.c1 = c1;
        this.c2 = c2;
    }

    public void setColor(Color c1, Color c2) {
        this.c1 = c1;
        this.c2 = c2;
        repaint();
    }
    
    public void setHighlight(Color c) {
        highlight = c;
        repaint();
    }
    
    public void setIcon(Icon icon) {
        this.icon = icon;
        repaint();
    }
    
    public void setTitle(String text) {
        title = text;
        repaint();
    }
    
    public String getTitle() {
        return title;
    }

    public void paintComponent(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;
        g2.setFont(getFont());
        GradientPaint gradient = new GradientPaint(0, 0, c1, 0, (int) (getHeight()), c2);
        g2.setPaint(gradient);
        g2.fillRect(0, 0, getWidth(), (int)(getHeight()));
        if (title != null) {
            g2.setColor(highlight);
            int height = g2.getFont().getSize();
            float left = indent + 5.f + (icon == null ? 0 : icon.getIconWidth());
            
            g2.drawString(title, left, (float)(0.5 * (getHeight() + height)));
            g2.setColor(getForeground());
            g2.drawString(title, left, (float)(0.5 * (getHeight() + height))-1);
        }
        if (icon != null) {
            icon.paintIcon(this, g2, indent, (int) (0.5 * (getHeight() - icon.getIconHeight())));
        }
    }
    
    public void setIndent(int indent) {
        this.indent = indent;
    }

}
