/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package controls;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import javax.swing.*;

/**
 *
 * @author stefano
 */
public class JDragger extends JPanel {
	int orientation = 0;

	public JDragger(final JSplitPane parent, final int orientation) {
		this.orientation = orientation;
		if (orientation == 0)
			setCursor(Cursor.getPredefinedCursor(Cursor.N_RESIZE_CURSOR));
		else
			setCursor(Cursor.getPredefinedCursor(Cursor.E_RESIZE_CURSOR));
        setPreferredSize(new Dimension(20, 20));
		addMouseMotionListener(new MouseMotionListener() {
			public void mouseDragged(MouseEvent evt) {
				if (orientation == 0) {
					int y = evt.getY();
					int newy = parent.getDividerLocation() + y;
					if (newy < parent.getMinimumDividerLocation()) {
						parent.setDividerLocation(parent.getMinimumDividerLocation());
					} else if (newy > parent.getMaximumDividerLocation())
						parent.setDividerLocation(parent.getMaximumDividerLocation());
					else
						parent.setDividerLocation(newy);
				} else if (orientation == 1) {
					int x = evt.getX();
					int newx = parent.getDividerLocation() + x;
					if (newx < parent.getMinimumDividerLocation()) {
						parent.setDividerLocation(parent.getMinimumDividerLocation());
					} else if (newx > parent.getMaximumDividerLocation())
						parent.setDividerLocation(parent.getMaximumDividerLocation());
					else
						parent.setDividerLocation(newx);
				}
			}

			public void mouseMoved(MouseEvent e) {
				//throw new UnsupportedOperationException("Not supported yet.");
			}
		});
	}


	public JDragger(final Object comp, final DraggerListener listener, final int orientation) {
		this.orientation = orientation;
		if (orientation == 0)
			setCursor(Cursor.getPredefinedCursor(Cursor.N_RESIZE_CURSOR));
		else
			setCursor(Cursor.getPredefinedCursor(Cursor.E_RESIZE_CURSOR));
		init(comp, listener, orientation);
        setPreferredSize(new Dimension(20, 15));
	}

	private void init(final Object comp, final DraggerListener listener, final int orientation) {
		addMouseMotionListener(new MouseMotionListener() {
			public void mouseDragged(MouseEvent evt) {
				if (orientation == 0) {
					listener.draggedTo(JDragger.this, comp, evt.getY());
				} else if (orientation == 1) {
					listener.draggedTo(JDragger.this, comp, evt.getX());
				}
			}

			public void mouseMoved(MouseEvent e) {
				//throw new UnsupportedOperationException("Not supported yet.");
			}
		});
	}

	public int getOrientation() {
		return orientation;
	}

	public void setOrientation(int orientation) {
		this.orientation = orientation;
		repaint();
	}

	@Override
	protected void paintComponent(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		int y = (int) (0.5 * getHeight());
		int x = (int) (0.5 * getWidth());
		
		if (orientation == 0) {
			g2.setColor(Color.GRAY);
			g2.drawLine(x - 5, y, x + 5, y);
			g2.drawLine(x - 5, y - 3, x + 5, y - 3);
			g2.drawLine(x - 5, y + 3, x + 5, y + 3);
			g2.setColor(new Color(230, 230, 230));
			g2.drawLine(x - 5, y + 1, x + 5, y + 1);
			g2.drawLine(x - 5, y - 2, x + 5, y - 2);
			g2.drawLine(x - 5, y + 4, x + 5, y + 4);

		} else {
			g2.setColor(Color.GRAY);
			g2.drawLine(x, y - 5, x, y + 5);
			g2.drawLine(x - 3, y - 5, x - 3, y + 5);
			g2.drawLine(x + 3, y - 5, x + 3, y + 5);
			g2.setColor(new Color(230, 230, 230));
			g2.drawLine(x + 1, y - 5, x + 1, y + 5);
			g2.drawLine(x - 2, y - 5, x - 2, y + 5);
			g2.drawLine(x + 4, y - 5, x + 4, y + 5);

		}
	}

	
}
