/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controls;

import java.awt.event.*;
import javax.swing.*;

/**
 *
 * @author stefano
 */
public class PersistentTextField extends JTextField {
    private String currentText;
    
    public PersistentTextField() {
        super();
        
        addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                currentText = getText();
            }
        });
    }
    
    @Override
    public void setText(String txt) {
        super.setText(txt);
        currentText = txt;
    }
    
    
    
    @Override
    protected void processFocusEvent(FocusEvent e) {
        if (e.getID() == FocusEvent.FOCUS_LOST && !getText().equals(currentText)) {
            setText(currentText);
        }
        super.processFocusEvent(e);
    }
}
