/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controls;

import java.awt.*;
import java.awt.image.*;
import icons.Icons;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;

/**
 *
 * @author stefano
 */
public class PopOver extends JPanel implements ComponentListener, MouseListener {
    private static BufferedImage popImage;
    private static PopOver p;
    private boolean rotate;
    private JComponent next;
    private JLayeredPane pane;
    
    
    private PopOver() {
        popImage = (BufferedImage) Icons.popOver;
        setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        setPreferredSize(new Dimension(popImage.getWidth(null), popImage.getHeight(null)));
        setOpaque(false);
        setLayout(new BorderLayout());
    }
    
    public static PopOver getPopOver(JComponent nextTo, JLayeredPane pane) {
        if (p == null) {
            p = new PopOver();
        } else {
            p.removeAll();
            p.pane.remove(p);
            p.pane.removeComponentListener(p);
            p.pane.removeMouseListener(p);
            p.next.removeComponentListener(p);
        }
        
        p.next = nextTo;
        p.next.addComponentListener(p);
        
        p.pane = pane;
        
        p.pane.setVisible(true);      
        p.pane.addComponentListener(p);
        p.pane.addMouseListener(p);
        pane.add(p, JLayeredPane.POPUP_LAYER);
        
        p.move();
        return p;
    }

    private void move() {
        Rectangle r = SwingUtilities.convertRectangle(next, new Rectangle(0, 0, 0, 0), pane);
        Dimension s = next.getSize();
        setSize(getPreferredSize());
        int x, y;
        
        if (r.x + s.width + getWidth() < pane.getWidth()) {
            rotate = false;
            x = r.x + s.width;
            y = (int)(r.y - 0.5*getHeight() + 0.5 * s.getHeight());
        } else {
            rotate = true;
            x = r.x - s.width - getWidth();
            y = (int)(r.y - 0.5*getHeight() + 0.5 * s.getHeight());
        }
        
        
        setBounds(x, y, getPreferredSize().width, getPreferredSize().height);
        revalidate();
        pane.revalidate();
    }
    
    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        
        Graphics2D g2 = (Graphics2D) g;
        
        if (rotate) {
            g2.drawImage(popImage, getWidth(), 0, 0, getHeight(), 
                    0, 0, getWidth(), getHeight(), this);
        } else {
            g2.drawImage(popImage, 0, 0, null);
        }
    }
    
    public static void dismiss() {
        p.pane.setVisible(false);
        p.pane.remove(p);
        p.pane.removeComponentListener(p);
        p.pane.removeMouseListener(p);
    }

    public void componentResized(ComponentEvent e) {
        move();
    }

    public void componentMoved(ComponentEvent e) {
        move();
    }

    public void componentShown(ComponentEvent e) {
        
    }

    public void componentHidden(ComponentEvent e) {
        
    }

    public void mouseClicked(MouseEvent e) {
        
    }

    public void mousePressed(MouseEvent e) {
        dismiss();
    }

    public void mouseReleased(MouseEvent e) {
        
    }

    public void mouseEntered(MouseEvent e) {
        
    }

    public void mouseExited(MouseEvent e) {
        
    }
    
}
