/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controls;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import utils.*;

/**
 *
 * @author stefano
 */
public class SourceList extends JPanel {
    private String[] elements;
    private String selected;
    private GradientPane[] listElements;
    
    private static int maxElements = 24;
    private Color c1 = new Color(187, 197, 214);
    private Color c2 = new Color(147, 160, 184);
    private ActionListener al;
    private Font normal;
    private Font bold;
    private JPopupMenu popupMenu;
    private boolean sorted = false;

    public boolean isSorted() {
        return sorted;
    }

    public void setSorted(boolean sorted) {
        this.sorted = sorted;
        updateLabels();
    }
    
    public SourceList(ActionListener l) {
        al = l;
        setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
        listElements = new GradientPane[maxElements];
        for (int i = 0; i < maxElements; i++) {
            listElements[i] = new GradientPane();
            listElements[i].setLayout(new FlowLayout(FlowLayout.RIGHT));
            listElements[i].add(new JLabel());
            listElements[i].setIndent(15);
            listElements[i].setVisible(false);
            
            final int sel = i;
            listElements[i].addMouseListener(new MouseAdapter() {
                public void mouseClicked(MouseEvent e) {
                    selected = elements[sel];
                    updateLabels();
                    al.actionPerformed(null);
                } 
                
                public void mousePressed(MouseEvent e) {
                    if (e.isPopupTrigger() && popupMenu != null) {
                        popupMenu.setInvoker(listElements[sel]);
                        popupMenu.show(listElements[sel], e.getX(), e.getY());
                    }
                }
            });
            
            normal = listElements[i].getFont();
            bold = listElements[i].getFont().deriveFont(Font.BOLD);
            
            add(listElements[i]);
        }
        setBackground(UIUtils.sidebarColor);
    }
    
    public void setPopupMenu(JPopupMenu pm) {
        popupMenu = pm;
    }
    
    public void setItems(String[] elements) {
        this.elements = elements;
        updateLabels();
    }
    
    public void setSelectedItem(String sel) {
        selected = sel;
        updateLabels();
    }
    
    public String getSelectedItem() {
        return selected;
    }
    
    private void updateLabels() {
        if (elements == null)
            return;
        if (sorted)
            Arrays.sort(elements);
        for (int i = 0; i < elements.length; i++) {
            listElements[i].setTitle(elements[i]);
            
            if (elements[i].equals(selected)) {
                listElements[i].setColor(c1, c2);
                listElements[i].setForeground(Color.white);
                listElements[i].setFont(bold);
                listElements[i].setHighlight(Color.black);
            } else {
                listElements[i].setColor(getBackground(), getBackground());
                listElements[i].setHighlight(null);
                listElements[i].setForeground(Color.black);
                listElements[i].setFont(normal);
            }
            listElements[i].setBorder(null);
            listElements[i].setVisible(true);
        }
        for (int i = elements.length; i < maxElements; i++)
            listElements[i].setVisible(false);
        
        setPreferredSize(new Dimension(0, elements.length * 20));
    }
    
    public void setIcon(int idx, Icon icon) {
        listElements[idx].setIcon(icon);
    }
    
    public void setInfo(int idx, String info) {
        ((JLabel) listElements[idx].getComponent(0)).setText(info);
    }
}
