/*
 * JulianDate.java
 * 
 * Created on Aug 20, 2007, 2:22:54 PM
 * 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package numal;

import java.util.Date;
import java.util.GregorianCalendar;

/**
 *
 * @author Ste
 * 
 * http://aa.usno.navy.mil/faq/docs/JD_Formula.html
 * 
 */
public class JulianDate {

    public JulianDate() {
    }
   
    static public int DateToJD(Date calendarDate) {
	
	GregorianCalendar calendar = new GregorianCalendar();
	calendar.setTime(calendarDate);
	
	
	int I = calendar.get(calendar.YEAR);
	int J = calendar.get(calendar.MONTH) + 1;
	int K = calendar.get(calendar.DATE);
	//System.out.println("DTOJD " + I + " " + J + " " + K);
	
	return K-32075+1461*(I+4800+(J-14)/12)/4+367*(J-2-(J-14)/12*12)/12-3*((I+4900+(J-14)/12)/100)/4;
    }
    
    static public Date JDToDate(int JD) {
	Date returnDate = new Date();
	int L, N, I, J, K;
	      
	L= JD+68569;
	N= 4*L/146097;
	L= L-(146097*N+3)/4;
	I= 4000*(L+1)/1461001;
	L= L-1461*I/4+31;
	J= 80*L/2447;
	K= L-2447*J/80;
	L= J/11;
	J= J+2-12*L;
	I= 100*(N-49)+I+L;
	
	//System.out.println("JDTOD " + I + " " + J + " " + K);
	
	GregorianCalendar calendar = new GregorianCalendar();
	calendar.setTime(returnDate);
	calendar.set(calendar.YEAR, I);
	calendar.set(calendar.MONTH, J - 1);
	calendar.set(calendar.DATE, K);
	
	return calendar.getTime();
    };
    
    static public GregorianCalendar JDToCalendar(int JD) {
	
	int L, N, I, J, K;
	      
	L= JD+68569;
	N= 4*L/146097;
	L= L-(146097*N+3)/4;
	I= 4000*(L+1)/1461001;
	L= L-1461*I/4+31;
	J= 80*L/2447;
	K= L-2447*J/80;
	L= J/11;
	J= J+2-12*L;
	I= 100*(N-49)+I+L;
	
	//System.out.println("JDTOD " + I + " " + J + " " + K);
	
	GregorianCalendar calendar = new GregorianCalendar();
	
	calendar.set(calendar.YEAR, I);
	calendar.set(calendar.MONTH, J - 1);
	calendar.set(calendar.DATE, K);
	
	return calendar;
    };
}
