/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package palette;

import controls.GradientPane;
import controls.JDragger;
import java.awt.*;
import javax.swing.*;
import utils.UIUtils;

/**
 *
 * @author stefano
 */
/*
class Splitter extends JPanel {
    private static Color col = new Color(102,102,102);
    
    public Splitter(final Container cont) {
        setOpaque(true);
        setBackground(col);
        setPreferredSize(new Dimension(0, 1));
        setCursor(Cursor.getPredefinedCursor(Cursor.N_RESIZE_CURSOR));
        this.addMouseMotionListener(new MouseMotionListener() {
            public void mouseDragged(MouseEvent e) {
                cont.setPreferredSize(new Dimension(0, Math.max(50, cont.getHeight() + e.getY())));
                cont.setMaximumSize(new Dimension(32768, cont.getPreferredSize().height));
                cont.setMinimumSize(new Dimension(50, Math.max(50, cont.getPreferredSize().height)));
                cont.revalidate();
            }

            public void mouseMoved(MouseEvent e) {
            //    throw new UnsupportedOperationException("Not supported yet.");
            }
        });
        
    }
}*/

public class Container extends JPanel {
    private GradientPane topTitle;
    private JComponent comp;
    private JPanel toolbar;
    
    private Container() {
        setOpaque(false);
    }
    
    public static Container getContainerWithHeader(JComponent comp, String title, JSplitPane lr_sp, JSplitPane tb_sp) {
        Container c = new Container();
        c.comp = comp;
        c.setLayout(new BorderLayout());
        
        c.topTitle = new GradientPane();
        c.topTitle.setLayout(new BorderLayout());
        
        c.topTitle.setTitle(title);
        c.setFont(c.topTitle.getFont().deriveFont(11f));
        c.topTitle.setPreferredSize(new Dimension(0, 20));
        c.add(c.topTitle, BorderLayout.NORTH);
        c.add(comp, BorderLayout.CENTER);
        
        
        
        
        if (lr_sp != null) {
            c.topTitle.add(new JDragger(lr_sp, 1), BorderLayout.WEST);
            c.topTitle.setIndent(15);
        }
        
        
        c.toolbar = new JPanel();
        c.toolbar.setLayout(new BoxLayout(c.toolbar, BoxLayout.LINE_AXIS));
        c.toolbar.setOpaque(false);
        
        JPanel rightSpace = new JPanel(new BorderLayout());
        rightSpace.add(c.toolbar, BorderLayout.CENTER);
        rightSpace.setOpaque(false);
        c.topTitle.add(rightSpace, BorderLayout.EAST);
        if (tb_sp != null) {
            rightSpace.add(new JDragger(tb_sp, 0), BorderLayout.EAST);
        }
        return c;
    }
    
    public static Container getContainerForSidebar(JComponent comp, String title) {
        Container c = Container.getContainerWithHeader(comp, title, null, null);
        c.topTitle.setBorder(null);
        c.topTitle.setForeground(UIUtils.sidebarHeaderColor);
        c.topTitle.setColor(UIUtils.sidebarColor, UIUtils.sidebarColor);
        c.topTitle.setFont(c.topTitle.getFont().deriveFont(Font.BOLD));
        c.setBackground(UIUtils.sidebarColor);
        return c;
    }
    
    @Override
    public void setFont(Font font) {
        super.setFont(font);
        if (topTitle != null)
            topTitle.setFont(font);
    }
    
    public Component getComponent() {
        return comp;
    }
    
    public JPanel getToolbar() {
        return toolbar;
    }
}
