/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ParametersPanel.java
 *
 * Created on Nov 25, 2008, 3:31:28 PM
 */

package palette;

import java.awt.*;
import java.beans.PropertyChangeListener;
import java.util.*;

import javax.swing.*;
import structs.*;

/**
 *
 * @author stefano
 */
public class ParametersPanel extends javax.swing.JPanel {

    private ArrayList<IPRow> rows;
    private ArrayList<Object> values;
    private ArrayList<String> titles;

    /** Creates new form ParametersPanel */
    public ParametersPanel() {
        setLayout(new GridBagLayout());
        rows = new ArrayList<IPRow>();
        values = new ArrayList<Object>();
        titles = new ArrayList<String>();
    }

    public void clear() {
        rows.clear();
        values.clear();
        titles.clear();
        removeAll();
    }

    public IPRow addRow(String title, Object initialValue, Class type) {
        return addRow(title, initialValue, type, null);
    }


    
    public void addRows(ParametersPanel src) {
        for (int i = 0; i < src.rows.size(); i++)
            addRow(src.rows.get(i).title, src.values.get(i), src.rows.get(i).classType, src.titles.get(i));
    }
    
    public IPRow addRow(String title, Object initialValue, Class type, String name) {

        IPRow row = new IPRow(type, title);
        row.title = " " + title;
        titles.add(name);
        row.setValue(initialValue);
        JLabel label = row.getLabel();
        label.setHorizontalAlignment(SwingConstants.RIGHT);

        GridBagConstraints c = new GridBagConstraints();
        if (type == Void.class) {
            c.gridx = 0;
            c.gridy = rows.size();
            c.gridwidth = 2;
            add(label, c);
        } else if (type == JSeparator.class) {
            c.gridx = 0;
            c.gridy = rows.size();
            c.gridwidth = 2;
            c.fill = GridBagConstraints.HORIZONTAL;
            c.anchor = GridBagConstraints.WEST;
            c.ipadx = 3;
            label.setHorizontalAlignment(JLabel.LEADING);
            label.setBorder(BorderFactory.createMatteBorder(0, 0, 2, 0, Color.GRAY));
	    label.setBackground(Color.LIGHT_GRAY);
	    label.setOpaque(true);
	    
            add(label, c);
        }else {
            c.gridx = 0;
            c.insets = new Insets(2, 3, 2, 4);
            c.gridy = rows.size();
            c.anchor = GridBagConstraints.EAST;
            add(label, c);

            c.gridx = 1;
            c.fill = GridBagConstraints.BOTH;
            c.anchor = GridBagConstraints.NORTHWEST;
            c.weightx = .9;
            add(row.getComponent(), c);
        }
        rows.add(row);

        int wh = Math.min((rows.size() + 1) * 50, 400);
        
        rows.get(0).getComponent().requestFocus();

        return row;
    }

    public void addSeparator(String title) {
	addRow(title, null, JSeparator.class);
    }

    public void setValues(ParametersPanel src) {
        ArrayList<Object> vals = src.getValues();
        for (int i = 0; i < vals.size(); i++)
            setValue(i, vals.get(i));
    }

    public ArrayList<Object> getValues() {
        values.clear();
        
        for (int i = 0; i < rows.size(); i++) {
            values.add(rows.get(i).getValue());
        }

        return values;
    }

    public IPRow getRow(int idx) {
        return rows.get(idx);
    }

    public Object getValue(String name) {
        if (titles.indexOf(name) != -1)
            return values.get(titles.indexOf(name));
        else
            return null;
    }

    public void setValue(String name, Object value) {
        rows.get(titles.indexOf(name)).setValue(value);
    }

    public void setValue(int idx, Object value) {
        rows.get(idx).setValue(value);
    }
    

    public boolean validateValues() {
         for (int i = 0; i < rows.size(); i++) {
            try {
                Object val = rows.get(i).getValue();
            } catch (Exception e) {
                JOptionPane.showMessageDialog(this, "Error parsing: \n" + titles.get(i));
                rows.get(i).getComponent().requestFocus();
                return false;
            }

        }

        return true;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
