/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package palette;

import java.awt.*;
import java.awt.event.ActionListener;
import javax.swing.*;
import utils.*;

/**
 *
 * @author stefano
 */
public class RangeField extends JPanel {
    private RangeField() {};

    private String title;
    private JTextField[] fields;
    private JLabel lab;

    public RangeField(String title, int nfields) {
        setLayout(new BoxLayout(this, BoxLayout.LINE_AXIS));
        lab = new JLabel(title);
        add(lab);

        JPanel cont = new JPanel(new GridLayout(1, 4));
        fields = new JTextField[nfields];
        for (int i = 0; i < nfields; i++) {
            fields[i] = new JTextField();
            fields[i].setColumns(6);
            cont.add(fields[i]);
        }

        add(cont);
    }

    public void addActionListener(ActionListener al) {
        for (int i = 0; i < fields.length; i++)
            fields[i].addActionListener(al);
    }

    public double[] getValues() {
        double[] ret = new double[fields.length];
        for (int i = 0; i < ret.length; i++) {
            if (! Utils.isNumeric(fields[i].getText())) {
                ret[i] = Double.NaN;
            } else
                ret[i] = Double.valueOf(fields[i].getText());
        }

        return ret;
    }

    public void setValues(double[] values) {
        for (int i = 0; i < values.length; i++)
            if (Double.isNaN(values[i]))
                fields[i].setText("");
            else
                fields[i].setText(String.format("%e", values[i]));
    }
}
