/*
 * inputParameters.java
 *
 * Created on April 15, 2008, 12:46 PM
 */
package palette;

/**
 *
 * @author  Ste
 */
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import structs.*;
import utils.CloseableWindow;
import utils.UIUtils;

public class inputParameters extends javax.swing.JDialog implements ActionListener, CloseableWindow {

    /** Creates new form inputParameters */
    private ParametersPanel mainPane;
    private ArrayList[] values;
    private ArrayList<ParametersPanel> pars;
    private Component focus;
    
    public inputParameters(java.awt.Frame parent, String title, boolean modal) {
        super(parent, modal);
        init(title);
    }

    public inputParameters(String title, boolean modal) {
        init(title);
    }

    public void init(String title) {
        initComponents();
        getRootPane().setDefaultButton(okButton);
        
        mainPane = new ParametersPanel();
        pars = new ArrayList<ParametersPanel>();
        pars.add(mainPane);
        scrollPane.setViewportView(mainPane);
        setLocationByPlatform(true);
        setTitle(title);
        setSize(550, 400);
     //   UIUtils.addWindowMenu(this, true);
    }

    public void addTab(String title) {
        ParametersPanel p = new ParametersPanel();
        JScrollPane spane = new JScrollPane(p);
        spane.setBorder(BorderFactory.createEmptyBorder());
        tabPane.addTab(title, spane);
        pars.add(p);
    }

    public void setTab(int tab, String title) {
        tabPane.setTitleAt(tab, title);
    }

    public IPRow addRow(String title, Object initialValue, Class type) {
        IPRow row = mainPane.addRow(title, initialValue, type);
        if ((type == String.class) || (type == ArrayList.class)) {
            if (focus == null)
                row.getComponent().requestFocus();
            focus = row.getComponent();
        }
        return row;
    }

    public IPRow addRow(int pan, String title, Object initialValue, Class type) {
        return pars.get(pan).addRow(title, initialValue, type);
    }

    public IPRow addRow(String title, Object initialValue, Class type, String name) {
        return mainPane.addRow(title, initialValue, type, name);
    }

    public IPRow addRow(int pan, String title, Object initialValue, Class type, String name) {
        return pars.get(pan).addRow(title, initialValue, type, name);
    }

    public void addSeparator(int pan) {
        pars.get(pan).addRow("", null, JSeparator.class);
    }

    public void addSeparator() {
        mainPane.addRow("", null, JSeparator.class);
    }


    public void addSeparator(int pan, String title) {
        pars.get(pan).addSeparator(title);
    }

    public void addSeparator(String title) {
        mainPane.addSeparator(title);
    }



    public void actionPerformed(ActionEvent e) {
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        tabPane = new javax.swing.JTabbedPane();
        scrollPane = new javax.swing.JScrollPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setModal(true);

        okButton.setText("OK");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        scrollPane.setBorder(null);
        tabPane.addTab("Main", scrollPane);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 429, Short.MAX_VALUE)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(cancelButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 234, Short.MAX_VALUE)
                .add(okButton)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(tabPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 280, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(cancelButton)
                    .add(okButton)))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
	doClose();
}//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
            for (int i = 0; i < pars.size(); i++) {
                if (!pars.get(i).validateValues())
                    return;
            }


            values = new ArrayList[pars.size()];

            for (int i = 0; i < pars.size(); i++)
                values[i] = pars.get(i).getValues();

            setVisible(false);
        
    }//GEN-LAST:event_okButtonActionPerformed

    public ArrayList getValues() {
        if (values == null)
            return null;
        return values[0];
    }

    public ArrayList getValues(int tab) {
        if (values == null)
            return null;
        return values[tab];
    }

    public Object getValue(String name) {
        return mainPane.getValue(name);
    }

    public Object getValue(String name, int pan) {
        return pars.get(pan).getValue(name);
    }


    public void doClose() {
	values = null;
        setVisible(false);

    }

    /**
     * @param args the command line arguments
     */

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton okButton;
    private javax.swing.JScrollPane scrollPane;
    private javax.swing.JTabbedPane tabPane;
    // End of variables declaration//GEN-END:variables

}
