/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package plotting;

import java.awt.*;


/**
 *
 * @author Ste
 */

public class CurveProp {
    private String name;
    private Color color = Color.BLACK;
    Color cycleTo;
    private BasicStroke stroke;
    boolean visible = true;
    static public int SOLID = 0;
    static public int DASHED = 1;
    static public int POINT = 2;
    static public int POINTDASH = 3;
    private int strokeType = SOLID;
    private int type = 0;

    static public int TYPE_NORMAL = 0;
    static public int TYPE_ELLIPSE = 1;
    private double scaling = 1.;

    public String[] strokeTypes;

    public CurveProp(String nam) {
        color = Color.BLACK;
        name = nam;
        cycleTo = null;
	stroke = new BasicStroke(1f);
	strokeTypes = new String[] { "SOLID", "DASHED", "POINT", "POINTDASH" };
    }

    private float[] getDashArray(int type) {
	if (type == SOLID)
	    return null;
	else if (type == DASHED)
	    return new float[] { 4f, 4f };
	else if (type == POINT) {
	    return new float[] { 2f, 2f};
	} else if (type == POINTDASH)
	    return new float[] { 5f, 2f, 2f, 2f};
	return null;
    }

    public CurveProp(String nam, Color col, Color ct, float width, int type) {
        color = col;
        cycleTo = ct;
        name = nam;
        setStroke(width, type);
	strokeTypes = new String[] { "SOLID", "DASHED", "POINT", "POINTDASH" };
    }

    public CurveProp(CurveProp prop) {
        color = prop.color;
        cycleTo = prop.cycleTo;
        name = prop.name;
        setStroke(prop.stroke.getLineWidth(), prop.strokeType);
	strokeTypes = new String[] { "SOLID", "DASHED", "POINT", "POINTDASH" };
    }

    public void setStroke(float width, int type) {
	strokeType = type;
	stroke = new BasicStroke(width, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 1f, getDashArray(type), 0f);
    }

    public String getStrokeName() {
	return strokeTypes[strokeType];
    }

    public int getStrokeType() {
	return strokeType;
    }

    public void setStrokeType(int type) {
	float w = stroke.getLineWidth();
	setStroke(w, type);
    }

    public void setStrokeType(String str) {
	for (int i = 0; i < strokeTypes.length; i++) {
	    if (strokeTypes[i].equals(str))
		setStrokeType(i);
	}

    }

    public String[] getStrokeTypes() {
	return strokeTypes;
    }

    public void setStrokeWidth(float w) {
	setStroke(w, strokeType);
    }
    public float getStrokeWidth() {
	return stroke.getLineWidth();
    }

    public BasicStroke getStroke() {
	return stroke;
    }

    public double getScaling() {
        return scaling;
    }

    public void setScaling(double scale) {
        scaling = scale;
    }

    /**
     * @return the color
     */
    public Color getColor() {
        if (color == null)
            color = Color.BLACK;
	return color;
    }

    /**
     * @param color the color to set
     */
    public void setColor(Color color) {
	this.color = color;
    }

    /**
     * @return the name
     */
    public String getName() {
	return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name) {
	this.name = name;
    }

    /**
     *
     */
    public void setType(int type) {
        this.type = type;
    }

}
