/*
 * PhaseWindow.java
 *
 * Created on April 14, 2008, 2:57 PM
 */

package plotting;

import javax.swing.*;

/**
 *
 * @author  Ste
 */
public class PhaseWindow extends javax.swing.JDialog {
    
    /** Creates new form PhaseWindow */
    public PhaseWindow(java.awt.Frame parent, boolean modal) {
	super(parent, modal);
	initComponents();
	period = 10;
	phase = 0;
    }
    double period;
    double phase;
    FoldPlot plotter;
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        phasePanel = new javax.swing.JPanel();
        labelPeriod = new javax.swing.JLabel();
        slidePeriod = new javax.swing.JSlider();
        textPeriod = new javax.swing.JTextField();
        labelPhase = new javax.swing.JLabel();
        slidePhase = new javax.swing.JSlider();
        textPhase = new javax.swing.JTextField();
        closeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Folding Period/phase");
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.PAGE_AXIS));

        phasePanel.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createEtchedBorder(), javax.swing.BorderFactory.createEmptyBorder(2, 2, 2, 2)));
        phasePanel.setLayout(new java.awt.GridLayout(3, 3, 0, 2));

        labelPeriod.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelPeriod.setText("Period [d]:");
        phasePanel.add(labelPeriod);

        slidePeriod.setMaximum(1000000);
        slidePeriod.setMinimum(10);
        slidePeriod.setValue(1000);
        slidePeriod.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                slidePeriodStateChanged(evt);
            }
        });
        phasePanel.add(slidePeriod);

        textPeriod.setText("10");
        textPeriod.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 2, true));
        textPeriod.setPreferredSize(new java.awt.Dimension(80, 22));
        textPeriod.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                textPeriodKeyPressed(evt);
            }
        });
        phasePanel.add(textPeriod);

        labelPhase.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labelPhase.setText("Phase [%]: ");
        phasePanel.add(labelPhase);

        slidePhase.setValue(0);
        slidePhase.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                slidePhaseStateChanged(evt);
            }
        });
        phasePanel.add(slidePhase);

        textPhase.setText("0");
        textPhase.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 2));
        textPhase.setPreferredSize(new java.awt.Dimension(80, 22));
        textPhase.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textPhaseActionPerformed(evt);
            }
        });
        textPhase.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                textPhaseKeyPressed(evt);
            }
        });
        phasePanel.add(textPhase);

        closeButton.setText("Close");
        closeButton.setMinimumSize(new java.awt.Dimension(29, 29));
        closeButton.setPreferredSize(new java.awt.Dimension(29, 29));
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });
        phasePanel.add(closeButton);

        getContentPane().add(phasePanel);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    
    public JPanel getPanel() {
	return phasePanel;
    }
    
    public void setPeriodVisible(boolean vis) {
	labelPeriod.setVisible(vis);
	textPeriod.setVisible(vis);
	slidePeriod.setVisible(vis);
    }
    
    private void slidePeriodStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_slidePeriodStateChanged
	textPeriod.setText(String.format("%.2f", ((double)slidePeriod.getValue())/100.));
	period = ((double)slidePeriod.getValue())/100.;
	
	if (plotter != null) {
	    plotter.setFoldPeriod(period);
	}
    }//GEN-LAST:event_slidePeriodStateChanged

    private void slidePhaseStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_slidePhaseStateChanged
	textPhase.setText(String.format("%d", slidePhase.getValue()));
	phase = ((double)slidePhase.getValue()) / 100.;
	
	if (plotter != null)
	    plotter.setPhase(phase);
	
    }//GEN-LAST:event_slidePhaseStateChanged

    private void textPhaseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textPhaseActionPerformed

    }//GEN-LAST:event_textPhaseActionPerformed

    private void textPeriodKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_textPeriodKeyPressed
	if (evt.getKeyCode() == evt.VK_ENTER) {
	    double P = Double.parseDouble(textPeriod.getText());
	    slidePeriod.setValue((int)(P * 100.));
	}
    }//GEN-LAST:event_textPeriodKeyPressed

    private void textPhaseKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_textPhaseKeyPressed
	if (evt.getKeyCode() == evt.VK_ENTER) {
	    int P = Integer.parseInt(textPhase.getText());
	    slidePhase.setValue(P);
	}

    }//GEN-LAST:event_textPhaseKeyPressed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
	if (plotter != null)
	plotter.hidePhaseDialog();
	setVisible(false);
	dispose();
	
    }//GEN-LAST:event_closeButtonActionPerformed
    
    public void setPeriod(double P) {
	slidePeriod.setValue((int) (P * 100.));
	
    }
    
    public void setPhase(double phase) {
	slidePhase.setValue((int) (phase * 100.));
    }
    
    
    public void setListener(FoldPlot plot) {
	plotter = plot;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
	java.awt.EventQueue.invokeLater(new Runnable() {
	    public void run() {
		PhaseWindow dialog = new PhaseWindow(new javax.swing.JFrame(), true);
		dialog.addWindowListener(new java.awt.event.WindowAdapter() {
		    public void windowClosing(java.awt.event.WindowEvent e) {
			System.exit(0);
		    }
		});
		dialog.setVisible(true);
	    }
	});
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JLabel labelPeriod;
    private javax.swing.JLabel labelPhase;
    private javax.swing.JPanel phasePanel;
    private javax.swing.JSlider slidePeriod;
    private javax.swing.JSlider slidePhase;
    private javax.swing.JTextField textPeriod;
    private javax.swing.JTextField textPhase;
    // End of variables declaration//GEN-END:variables
    
}
