/*
 * ResidualsWindow.java
 *
 * Created on April 24, 2008, 11:41 AM
 */
package plotting;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

/**
 *
 * @author  Ste
 */
public class ResidualsWindow extends javax.swing.JFrame implements ActionListener {

    FoldPlot plotter;
    int foldState = 0;
    ResidualsWindowListener listener;
    JCheckBoxMenuItem miControlled;
    JCheckBoxMenuItem miNone;
    JCheckBoxMenuItem miCustom;
    boolean docked = false;

    /** Creates new form ResidualsWindow */
    public ResidualsWindow(ResidualsWindowListener rwl, FoldPlot fp) {
        initComponents();
        panelPlot.setLayout(new BoxLayout(panelPlot, BoxLayout.Y_AXIS));
        plotter = new FoldPlot("residuals");
        plotter.setYTics(4);
        plotter.setXTics(4);
        panelPlot.add(plotter);
        plotter.setXLabel("Time");
        plotter.setYLabel("Residuals");
        miControlled = new JCheckBoxMenuItem("    Lock to main window", true);
        miControlled.addActionListener(this);
        miControlled.setActionCommand("locked");

        miNone = new JCheckBoxMenuItem("    No folding");
        miNone.addActionListener(this);
        miNone.setActionCommand("none");

        miCustom = new JCheckBoxMenuItem("    Custom phase");
        miCustom.addActionListener(this);
        miCustom.setActionCommand("custom");

        JMenuItem mi = new JMenuItem("Residuals Folding");
        Font boldFont = new Font(mi.getFont().getFamily(), Font.BOLD, mi.getFont().getSize());
        mi.setEnabled(false);
        mi.setFont(boldFont);

        plotter.getCustomMenu().add(new JSeparator());
        plotter.getCustomMenu().add(mi);
        plotter.getCustomMenu().add(miControlled);
        plotter.getCustomMenu().add(miNone);
        plotter.getCustomMenu().add(miCustom);


        plotter.getCustomMenu().add(new JSeparator());

        mi = new JMenuItem("Dock/undock from main window");
        mi.addActionListener(this);
        mi.setActionCommand("dock");

        plotter.getCustomMenu().add(mi);

        btnDock.addActionListener(this);
        btnDock.setActionCommand("dock");
        setListener(rwl);

      
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        bottomPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        comboFold = new javax.swing.JComboBox();
        btnDock = new javax.swing.JButton();
        panelPlot = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Residuals Plot");
        setAlwaysOnTop(true);
        setLocationByPlatform(true);

        jLabel1.setFont(jLabel1.getFont().deriveFont(jLabel1.getFont().getStyle() | java.awt.Font.BOLD, jLabel1.getFont().getSize()-2));
        jLabel1.setText("Folding :");

        comboFold.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Lock to main window", "None", "Custom" }));
        comboFold.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                comboFoldItemStateChanged(evt);
            }
        });
        comboFold.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                comboFoldActionPerformed(evt);
            }
        });

        btnDock.setText("<");
        btnDock.setToolTipText("Dock to main window");

        org.jdesktop.layout.GroupLayout bottomPanelLayout = new org.jdesktop.layout.GroupLayout(bottomPanel);
        bottomPanel.setLayout(bottomPanelLayout);
        bottomPanelLayout.setHorizontalGroup(
            bottomPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(bottomPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(comboFold, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 124, Short.MAX_VALUE)
                .add(btnDock))
        );
        bottomPanelLayout.setVerticalGroup(
            bottomPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(bottomPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 42, Short.MAX_VALUE)
                .add(comboFold, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(btnDock))
        );

        panelPlot.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        org.jdesktop.layout.GroupLayout panelPlotLayout = new org.jdesktop.layout.GroupLayout(panelPlot);
        panelPlot.setLayout(panelPlotLayout);
        panelPlotLayout.setHorizontalGroup(
            panelPlotLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 436, Short.MAX_VALUE)
        );
        panelPlotLayout.setVerticalGroup(
            panelPlotLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 289, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, bottomPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(panelPlot, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(panelPlot, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(bottomPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void comboFoldItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_comboFoldItemStateChanged

    }//GEN-LAST:event_comboFoldItemStateChanged

    private void comboFoldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_comboFoldActionPerformed
        if (comboFold.getSelectedIndex() == 0) {
            plotter.setFoldType(FoldPlot.FT_CONTROLLED);
            if (listener != null) {
                listener.residualsUpdated();
            }
            plotter.hidePhaseDialog();
            miControlled.setSelected(true);
            miNone.setSelected(false);
            miCustom.setSelected(false);
        } else if (comboFold.getSelectedIndex() == 1) {
            plotter.setFoldType(FoldPlot.FT_NONE);
            plotter.hidePhaseDialog();
            miControlled.setSelected(false);
            miNone.setSelected(true);
            miCustom.setSelected(false);
        } else if (comboFold.getSelectedIndex() == 2) {
            plotter.setFoldType(FoldPlot.FT_CUSTOM);
            if (listener != null) {
                listener.residualsUpdated();
            }
            plotter.showPhaseDialog(" Residuals");
            miControlled.setSelected(false);
            miNone.setSelected(false);
            miCustom.setSelected(true);
        }
    }//GEN-LAST:event_comboFoldActionPerformed

    public boolean isDocked() {
        return docked;
    }

    public void setListener(ResidualsWindowListener rwl) {
        listener = rwl;
    }

    public int getFoldState() {
        return foldState;
    }

    public FoldPlot getPlotter() {
        return plotter;
    }

    public JPanel getPlotterPanel() {
        return panelPlot;
    }

    public void dock(boolean d) {
        if (listener != null) {
            listener.attachDetachResiduals(this, d);
        
            docked = d;
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new ResidualsWindow(null, null).setVisible(true);
            }
        });
    }
    public static int FT_LOCK = 0;
    public static int FT_CUSTOM = 1;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel bottomPanel;
    private javax.swing.JButton btnDock;
    private javax.swing.JComboBox comboFold;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel panelPlot;
    // End of variables declaration//GEN-END:variables

    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("locked"))
            comboFold.setSelectedIndex(0);
        else if (e.getActionCommand().equals("none"))
            comboFold.setSelectedIndex(1);
        else if (e.getActionCommand().equals("custom"))
            comboFold.setSelectedIndex(2);
        else if (e.getActionCommand().equals("dock")) {
            dock(!docked);
        }
    }
}
