/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package repl;

import java.awt.*;
import javax.swing.*;
import utils.*;
import icons.Icons;
import java.awt.event.*;
import java.io.*;
import java.util.*;

/**
 *
 * @author stefano
 */
public class Frame extends javax.swing.JFrame implements NotificationListener {
    private Console c;
    private static Frame instance;
    private Controller controller = Controller.newController();
    private JLayeredPane popupPane;
    
    private static ArrayList<Frame> frames = new ArrayList<Frame>();
    /**
     * Creates new form Frame
     */
    public static Frame newFrame() {
        
        instance = new Frame();
        instance.setLocationByPlatform(true);
        
        frames.add(instance);
        return instance;
    }
    
    private Frame() {
        getRootPane().putClientProperty("apple.awt.brushMetalLook", Boolean.TRUE);
        initComponents();
        c = new Console(controller, this);
        container.removeAll();
        container.setLayout(new BorderLayout());
        container.add(c, BorderLayout.CENTER);
        
        controller.addGUIListener(this);

        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                c.getTerminal().exec("k = kernel.new()");
                c.getTerminal().defaultFocus();
            }
        });
        progress.putClientProperty("JComponent.sizeVariant", "mini");
        
        stop.setIcon(Icons.stop);
        stop.setBorder(BorderFactory.createEmptyBorder(4, 0, 2, 4));
        stop.setOpaque(false);
        stop.setVisible(false);
        
        popupPane = new JLayeredPane();
        setGlassPane(popupPane);
        
        addWindowListener(new WindowListener() {
            public void windowOpened(WindowEvent e) {
            }

            public void windowClosing(WindowEvent e) {
                if (JOptionPane.showConfirmDialog(Frame.this, "Do you want to close this window?\nAll your work will be lost.",
                        "", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                    Frame.this.closeFrame();
                }
            }

            public void windowClosed(WindowEvent e) {
            }

            public void windowIconified(WindowEvent e) {
            }

            public void windowDeiconified(WindowEvent e) {
            }

            public void windowActivated(WindowEvent e) {
            }

            public void windowDeactivated(WindowEvent e) {
            }
            
        });
        
        
        UIUtils.addPopupMenu(newWindow, 
                UIUtils.createPopupMenu(
                    UIUtils.createMenuItem(this, "New session", "newSession", null, null),
                    UIUtils.createMenuItem(this, "Open session...", "openSession", null, null),
                    UIUtils.createMenuItem(this, "Save session...", "saveSession", null, null)
                ));
        
    }
    
    public void newSession() {
        Frame.newFrame().setVisible(true);
    }
    
    public void openSession() {
        final String fn = UIUtils.openFile("Open session...");
        
        if (fn != null) {
            final Frame f = Frame.newFrame();
            f.setVisible(true);
            SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    f.c.getTerminal().exec(String.format("gui.load('%s')", fn));
                }
            });
            
            
        }
    }
    
    public void saveSession() {
        String fn = UIUtils.saveFile("Save session...");
        
        c.getTerminal().exec(String.format("gui.save('%s')", fn));
    }
    
    
    private void closeFrame() {
        frames.remove(this);
        if (frames.size() == 0) {
            System.exit(0);
        }
        setVisible(false);
        dispose();
    }

    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        rightSidebarGroup = new javax.swing.ButtonGroup();
        toolbar = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        newWindow = new controls.JMacButton();
        filler4 = new javax.swing.Box.Filler(new java.awt.Dimension(4, 0), new java.awt.Dimension(4, 0), new java.awt.Dimension(4, 32767));
        openSystem = new controls.JMacButton();
        btnOpen = new controls.JMacButton();
        btnSave = new controls.JMacButton();
        filler5 = new javax.swing.Box.Filler(new java.awt.Dimension(4, 0), new java.awt.Dimension(4, 0), new java.awt.Dimension(4, 32767));
        minimize = new controls.JMacButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        bezel1 = new controls.Bezel();
        status = new controls.AnimatedLabel();
        progress = new javax.swing.JProgressBar();
        stop = new javax.swing.JButton();
        filler2 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        jPanel1 = new javax.swing.JPanel();
        container = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setPreferredSize(new java.awt.Dimension(1280, 800));
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                formComponentResized(evt);
            }
        });

        toolbar.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 5, 0, 5));
        toolbar.setMinimumSize(new java.awt.Dimension(10, 40));
        toolbar.setPreferredSize(new java.awt.Dimension(10, 40));
        toolbar.setLayout(new javax.swing.BoxLayout(toolbar, javax.swing.BoxLayout.LINE_AXIS));

        jPanel2.setOpaque(false);
        jPanel2.setPreferredSize(new java.awt.Dimension(260, 100));
        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 0, 5));

        newWindow.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/newwindow.png"))); // NOI18N
        newWindow.setToolTipText("Open a new window");
        newWindow.setButtonType("segmentedTextured");
        newWindow.setFocusable(false);
        newWindow.setMinimumSize(new java.awt.Dimension(44, 29));
        newWindow.setSegmentPosition(-1);
        jPanel2.add(newWindow);
        jPanel2.add(filler4);

        openSystem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/systems.png"))); // NOI18N
        openSystem.setToolTipText("Data browser");
        openSystem.setButtonType("segmentedTextured");
        openSystem.setPreferredSize(new java.awt.Dimension(44, 28));
        openSystem.setSegmentPosition(0);
        openSystem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openSystemActionPerformed(evt);
            }
        });
        jPanel2.add(openSystem);

        btnOpen.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/open.png"))); // NOI18N
        btnOpen.setToolTipText("Open kernel");
        btnOpen.setButtonType("segmentedTextured");
        btnOpen.setFocusable(false);
        btnOpen.setPreferredSize(new java.awt.Dimension(44, 28));
        btnOpen.setSegmentPosition(1);
        btnOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOpenActionPerformed(evt);
            }
        });
        jPanel2.add(btnOpen);

        btnSave.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/save.png"))); // NOI18N
        btnSave.setToolTipText("Save kernel");
        btnSave.setButtonType("segmentedTextured");
        btnSave.setFocusable(false);
        btnSave.setPreferredSize(new java.awt.Dimension(44, 28));
        btnSave.setSegmentPosition(2);
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });
        jPanel2.add(btnSave);
        jPanel2.add(filler5);

        minimize.setText("Minimize");
        minimize.setButtonType("segmentedTextured");
        minimize.setFocusable(false);
        minimize.setMinimumSize(new java.awt.Dimension(85, 29));
        minimize.setSegmentPosition(-1);
        minimize.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                minimizeActionPerformed(evt);
            }
        });
        jPanel2.add(minimize);

        toolbar.add(jPanel2);
        toolbar.add(filler1);

        bezel1.setBorder(javax.swing.BorderFactory.createEmptyBorder(2, 2, 2, 2));
        bezel1.setMaximumSize(new java.awt.Dimension(300, 30));
        bezel1.setPreferredSize(new java.awt.Dimension(400, 30));
        bezel1.setLayout(new java.awt.BorderLayout(5, 5));

        status.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        status.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        bezel1.add(status, java.awt.BorderLayout.CENTER);

        progress.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(153, 153, 153), 2));
        progress.setIndeterminate(true);
        progress.setPreferredSize(new java.awt.Dimension(146, 6));
        bezel1.add(progress, java.awt.BorderLayout.PAGE_END);

        stop.setPreferredSize(new java.awt.Dimension(16, 12));
        stop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stopActionPerformed(evt);
            }
        });
        bezel1.add(stop, java.awt.BorderLayout.EAST);

        toolbar.add(bezel1);
        toolbar.add(filler2);

        jPanel1.setPreferredSize(new java.awt.Dimension(260, 10));
        toolbar.add(jPanel1);

        getContentPane().add(toolbar, java.awt.BorderLayout.NORTH);

        container.setMinimumSize(new java.awt.Dimension(1280, 768));
        container.setPreferredSize(new java.awt.Dimension(1280, 768));
        container.setLayout(new java.awt.BorderLayout());
        getContentPane().add(container, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void openSystemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openSystemActionPerformed
        c.switchRightSidebar("browser");
    }//GEN-LAST:event_openSystemActionPerformed

    private void minimizeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_minimizeActionPerformed
        c.getTerminal().exec(String.format("%s:minimize()", controller.getKernel()));
    }//GEN-LAST:event_minimizeActionPerformed

    private void stopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stopActionPerformed
        controller.getInstance().signalStop();
    }//GEN-LAST:event_stopActionPerformed

    private void btnOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOpenActionPerformed
        String fn = UIUtils.openFile("Open kernel...");
        if (fn != null) {
            c.getTerminal().setInput("# = kernel.new('" + fn + "')").requestFocusInWindow();
        }
    }//GEN-LAST:event_btnOpenActionPerformed

    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
        String fn = UIUtils.saveFile("Save kernel...");
        if (fn != null) {
            c.getTerminal().exec(String.format("%s:save('%s')", controller.getKernel(),
                    fn));
        }
    }//GEN-LAST:event_btnSaveActionPerformed

    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized
        c.updateSizes();        
    }//GEN-LAST:event_formComponentResized

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Frame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Frame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Frame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Frame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the form
         */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Frame().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private controls.Bezel bezel1;
    private controls.JMacButton btnOpen;
    private controls.JMacButton btnSave;
    private javax.swing.JPanel container;
    private javax.swing.Box.Filler filler1;
    private javax.swing.Box.Filler filler2;
    private javax.swing.Box.Filler filler4;
    private javax.swing.Box.Filler filler5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private controls.JMacButton minimize;
    private controls.JMacButton newWindow;
    private controls.JMacButton openSystem;
    private javax.swing.JProgressBar progress;
    private javax.swing.ButtonGroup rightSidebarGroup;
    private controls.AnimatedLabel status;
    private javax.swing.JButton stop;
    private javax.swing.JPanel toolbar;
    // End of variables declaration//GEN-END:variables

    public void notification(Notification n) {
        if (n.is(Controller.TYPE_BUSY)) {
            status.setText("Working...");
            progress.setIndeterminate(true);
            progress.setVisible(true);
        } else if (n.is(Controller.TYPE_READY)) {
            status.setText("Ready.");
            progress.setVisible(false);
            stop.setVisible(false);
        } else if (n.is(Controller.TYPE_PROGRESS)) {
            String[] info = n.name.split("\\|");
            int max = Integer.valueOf(info[1]);
            int cur = Integer.valueOf(info[0]);
            double val = Double.valueOf(info[2]);
            String what = info[3];
            
            progress.setIndeterminate(false);
            progress.setMaximum(max);
            progress.setValue(cur);
            status.setTextImmediately(String.format("%s, val = %.2e [%d/%d]", what, val, cur, max));
            stop.setVisible(true);
        }
        
    }
    
    public JLayeredPane getPopupLayer() {
        return popupPane;
    }
}
