/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package structs;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.File;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.event.*;
import utils.Utils;


/**
 *
 * @author Ste
 */
public class IPRow {
    public Class classType;
    
    public String title;
    private Component comp;
    private File fn;
    private JButton btn;
    private JLabel lbl;
    private JSlider rbox;
    private JSlider gbox;
    private JSlider bbox;
    private JDialog colorFrame;
    private JTextField field1;
    private JTextField field2;
    private JLabel lblTitle;
    private Component w;
    private PropertyChangeListener listener;


    public IPRow(Class classT, final String label) {
        final Component w = SwingUtilities.getRoot(comp);

        classType = classT;
        lblTitle = new JLabel(label);

        if ((classType == String.class) || (classType == Double.class) || (classType == Integer.class)) {
            comp = new JTextField();
            ((JTextField) comp).addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    if (listener != null) {
                        PropertyChangeEvent evt = new PropertyChangeEvent(this, label, null, null);
                        listener.propertyChange(evt);
                    }
                }
            });
            //((JTextField) comp).setColumns(10);
            
        } else if (classType == Boolean.class) {
            comp = new JCheckBox();

            ((JCheckBox) comp).addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    if (listener != null) {
                        PropertyChangeEvent evt = new PropertyChangeEvent(comp, label, null, null);
                        listener.propertyChange(evt);
                    }
                }
            });
        } else if (classType == Void.class) {
            comp = new JLabel();
	} else if (classType == Range.class) {

	    JPanel pan = new JPanel();
	    field1 = new JTextField();
	    field2 = new JTextField();
	    pan.setLayout(new GridLayout(1, 2));
	    pan.add(field1);
	    pan.add(field2);

	    comp = pan;
        } else if (classType == ArrayList.class) {
            comp = new JComboBox();
            ((JComboBox) comp).putClientProperty("JComboBox.isSquare", true);
            ((JComboBox) comp).addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    if (listener != null) {
                        PropertyChangeEvent evt = new PropertyChangeEvent(comp, label, null, null);
                        listener.propertyChange(evt);
                    }
                }
            });
        } else if (classType == JButton.class) {

            comp = new JButton();
            ((JButton) comp).setText(label);
	    ((JButton) comp).putClientProperty("JButton.buttonType", "gradient");

            lblTitle.setText("");

        }else if (classType == JSeparator.class) {
            comp = new JPanel();
            ((JPanel) comp).setLayout(new BoxLayout((JPanel) comp, BoxLayout.LINE_AXIS));
            ((JPanel) comp).add(new JSeparator());

            lblTitle.setFont(new Font(lblTitle.getFont().getFamily(), Font.ITALIC, lblTitle.getFont().getSize()));
        } else if (classType == File.class) {
            comp = new JPanel();
            ((JPanel) comp).setLayout(new BoxLayout((JPanel) comp, BoxLayout.LINE_AXIS));
            
            btn = new JButton();
	    btn.putClientProperty("JButton.buttonType", "gradient");

	    UIDefaults defaults = UIManager.getDefaults( );
	    btn.setIcon(defaults.getIcon( "FileView.directoryIcon" ));

	    ((JPanel) comp).add(btn);
	    
            lbl = new JLabel("<no file selected>");
            ((JPanel) comp).add(lbl);

            btn.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    Component w = SwingUtilities.getRoot(comp);
                    FileDialog fd = null;

                    if (w instanceof Frame)
                        fd = new FileDialog((Frame) w, "", FileDialog.SAVE);
                    else
                        fd = new FileDialog((Dialog) w, "", FileDialog.SAVE);

                    if (fn != null)
                        fd.setFile(fn.getPath());
                    
                    fd.setVisible(true);
                    if (fd.getFile() != null) {
                        fn = new File(fd.getDirectory() + File.separator + fd.getFile());
                        lbl.setText(fn.getName());
                    }

                    if (listener != null) {
                        PropertyChangeEvent evt = new PropertyChangeEvent(comp, label, null, null);
                        listener.propertyChange(evt);
                    }
               
                }

            });

            fn = null;
        }else if (classType == FileDialog.class) {
            comp = new JPanel();
            ((JPanel) comp).setLayout(new BoxLayout((JPanel) comp, BoxLayout.LINE_AXIS));

            btn = new JButton("...");
	    btn.putClientProperty("JButton.buttonType", "gradient");

            ((JPanel) comp).add(btn);

            lbl = new JLabel("<no file selected>");
            ((JPanel) comp).add(lbl);

            btn.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    Component w = SwingUtilities.getRoot(comp);
                    FileDialog fd = null;

                    if (w instanceof Frame)
                        fd = new FileDialog((Frame) w, "", FileDialog.LOAD);
                    else
                        fd = new FileDialog((Dialog) w, "", FileDialog.LOAD);

                    if (fn != null)
                        fd.setFile(fn.getPath());

                    fd.setVisible(true);
                    if (fd.getFile() != null) {
                        fn = new File(fd.getDirectory() + File.separator + fd.getFile());
                        lbl.setText(fn.getName());
                    }

                    if (listener != null) {
                        PropertyChangeEvent evt = new PropertyChangeEvent(comp, label, null, null);
                        listener.propertyChange(evt);
                    }

                }

            });

            fn = null;
        } else if (classType == Color.class) {
            JPanel pan = new JPanel();
            pan.setLayout(new BoxLayout(pan, BoxLayout.LINE_AXIS));

            btn = new JButton(" ... ");
	    btn.putClientProperty("JButton.buttonType", "gradient");
            lbl = new JLabel("      ");
            lbl.setOpaque(true);
            lbl.setBackground(new Color(0, 0, 0));

	    pan.add(new JLabel("   "));
            pan.add(lbl);
            pan.add(new JLabel("   "));
            pan.add(btn);
            
            btn.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    JColorChooser jc = new JColorChooser(lbl.getBackground());
                    Color nc = JColorChooser.showDialog(btn, "Color chooser", lbl.getBackground());
		    if (nc != null)
			lbl.setBackground(nc);
                    if (listener != null) {
                        PropertyChangeEvent evt = new PropertyChangeEvent(comp, label, null, null);
                        listener.propertyChange(evt);
                    }
                }

            });

            
            comp = pan;
        }

    }

    public Object getValue() {
        if (classType == String.class) {
            return ((JTextField) comp).getText();
        } else if (classType == Double.class) {
            if (((JTextField) comp).getText().trim().equals(""))
                return null;
            return Double.parseDouble(((JTextField) comp).getText());
        }  else if (classType == Integer.class) {
            if (((JTextField) comp).getText().trim().equals(""))
                return null;
            return Integer.parseInt(((JTextField) comp).getText());
        } else if (classType == Boolean.class) {
            return ((JCheckBox) comp).isSelected();
        } else if (classType == File.class) {
            return fn;
        } else if (classType == FileDialog.class) {
            return fn;
        } else if (classType == ArrayList.class) {
            return ((JComboBox) comp).getSelectedItem();
        } else if (classType == Color.class) {
            return lbl.getBackground();
	} else if (classType == Range.class) {
	    Range r = new Range(Utils.stringToDouble(field1.getText(), null),
	    Utils.stringToDouble(field2.getText(), null));
	    return r;
        } else
            return null;
        
    }

    public void setListener(PropertyChangeListener l) {
        listener = l;
    }

    public void setValue(Object value) {
        if (value == null)
            return;
        
        if (classType == String.class) {
            ((JTextField) comp).setText((String) value);
        } else if (classType == Double.class) {
            ((JTextField) comp).setText(Double.toString((Double) value));
        }  else if (classType == Integer.class) {
            ((JTextField) comp).setText(Integer.toString((Integer) value));
        } else if (classType == Boolean.class) {
            ((JCheckBox) comp).setSelected((Boolean) value);
        } else if (classType == File.class) {

            fn = (File) value;
            if (fn != null)
                lbl.setText(fn.getName());
            else
                lbl.setText("<no file selected>");
        } else if (classType == FileDialog.class) {

            fn = (File) value;
            if (fn != null)
                lbl.setText(fn.getName());
            else
                lbl.setText("<no file selected>");
        } else if (classType == ArrayList.class) {
            ArrayList l = (ArrayList) value;
            DefaultComboBoxModel m = (DefaultComboBoxModel) ((JComboBox) comp).getModel();
            m.removeAllElements();

            if (l != null)
                for (int i = 0; i < l.size(); i++)
                    m.addElement(l.get(i));
        } else if (classType == Color.class) {
            Color col = (Color) value;
            lbl.setBackground(col);
        } else if (classType == Range.class) {
	    Range r = (Range) value;
	    if (r == null)
		return;
	    
	    if (r.min != null)
		field1.setText(r.min.toString());
	    if (r.max != null)
		field2.setText(r.max.toString());

	}
    }

    public Component getComponent() {
        return comp;
    }

    public JLabel getLabel() {
        return lblTitle;
    }
}