/*
 * parametersBag.java
 *
 * Created on March 17, 2007, 9:22 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package structs;

import java.io.PrintStream;
import java.io.PrintWriter;
import utils.Utils;
import static structs.Constants.*;

/**
 *
 * @author Ste
 */
public class parametersBag {
    public double[] P;
    public double[] mass;
    public double[] ecc;
    public double[] meanAnom;
    public double[] longPeri;
    public double[] offsets;
    public double[] inc;
    public double[] node;
    public double[] radius;
    
    public double chisq;
    
    public int flag;
    
    public parametersBag(int nP, int nO) {
        init(nP, nO);
    }

    private void init(int nP, int nO) {
        nPlanets = nP;
	nOffsets = nO;
	P = new double[nP];
	mass = new double[nP];
	ecc = new double[nP];
	meanAnom = new double[nP];
	longPeri = new double[nP];
	offsets = new double[nO];
	inc = new double[nP];
	node = new double[nP];
	radius = new double[nP];
    }

    public parametersBag(double[][] ic, double[] voffsets) {
        init(ic.length, voffsets.length);
        offsets = Utils.copy(voffsets);

        for (int i = 0; i < ic.length; i++) {
            P[i] = ic[i][0];
            mass[i] = ic[i][1];
            meanAnom[i] = ic[i][2];
            ecc[i] = ic[i][3];
            longPeri[i] = ic[i][4];
            inc[i] = ic[i][5];
            node[i] = ic[i][6];
        }

    }

    public boolean isInvalid() {

        for (int i = 0; i < nPlanets; i++) {
            if (P[i] < 0.)
                return true;
            if (mass[i] < 0.)
                return true;
            if ((ecc[i] < 0.) || (ecc[i] > 0.9999))
                return true;
	    if ((inc[i] < 0.) || (inc[i] > 1.))
	        return true;
        }
        return false;


    }

    public double[][] getTable() {
        double[][] ret = new double[nPlanets][OESIZE];

        for (int i = 0; i < nPlanets; i++) {
            ret[i][0] = P[i];
            ret[i][1] = mass[i];
            ret[i][2] = meanAnom[i];
            ret[i][3] = ecc[i];
            ret[i][4] = longPeri[i];
	    ret[i][5] = inc[i];
	    ret[i][6] = node[i];
	    ret[i][7] = radius[i];
        }

        return ret;
    }
    
    public void save(PrintWriter stream, String header) {
	
	    for (int j = 0; j < getPlanets(); j++) {
		stream.println(header + "Planet" + Integer.toString(j+1) + ".Period\t" + Double.toString(P[j]));
		stream.println(header + "Planet" + Integer.toString(j+1)+ ".Eccentricity\t" + Double.toString(ecc[j]));
		stream.println(header + "Planet" + Integer.toString(j+1)+ ".LongOfPeri\t" + Double.toString(longPeri[j]));
		stream.println(header + "Planet" + Integer.toString(j+1)+ ".Mass\t" + Double.toString(mass[j]));
		stream.println(header + "Planet" + Integer.toString(j+1)+ ".MeanAnomaly\t" + Double.toString(meanAnom[j]));
		stream.println(header + "Planet" + Integer.toString(j+1)+ ".Inclination\t" + Double.toString(inc[j]));
		stream.println(header + "Planet" + Integer.toString(j+1)+ ".Node\t" + Double.toString(node[j]));
		stream.println(header + "Planet" + Integer.toString(j+1)+ ".Radius\t" + Double.toString(radius[j]));

	    };
	    
	    for (int j = 0; j < getOffsets(); j++) {
		stream.println(header + "Offset" + Integer.toString(j+1) + "\t" + Double.toString(offsets[j]));
	    };

        stream.println(header + "ChiSq" + chisq);
	
    }
    
    public int getPlanets() {
	return nPlanets;
    }

    public int getOffsets() {
	return nOffsets;
    }
    
    public void sortByPeriod() {
	
	int exch = 1;
	
	while (exch != 0) {
	    exch = 0;
	    for (int i = 1; i < getPlanets(); i++) {
		if (P[i-1] > P[i]) {
		    double Pi = P[i];
		    double Lopi = longPeri[i];
		    double Mi = mass[i];
		    double ecci = ecc[i];
		    double Mai = meanAnom[i];
		    double inci = inc[i];
		    double nodei = node[i];
		    double ri = radius[i];

		    P[i] = P[i-1];
		    longPeri[i] = longPeri[i-1];
		    mass[i] = mass[i-1];
		    ecc[i] = ecc[i-1];
		    meanAnom[i] = meanAnom[i-1];
		    inc[i] = inc[i-1];
		    node[i] = node[i-1];
		    radius[i] = radius[i-1];
		    
		    P[i-1] = Pi;
		    longPeri[i-1] = Lopi;
		    mass[i-1] = Mi;
		    ecc[i-1] = ecci;
		    meanAnom[i-1] = Mai;
		    inc[i-1] = inci;
		    node[i-1] = nodei;
		    radius[i-1] = ri;
		    exch++;
		    
		}
	    }
	    
	}
	
    }
        
    private int nPlanets;
    private int nOffsets;
    
}
