/*
 * transitsBag.java
 *
 * Created on May 17, 2007, 10:49 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package structs;

import java.io.*;
import java.util.*;


/**
 *
 * @author Ste
 */

public class transitsBag implements Serializable {
    private ArrayList<transit> centralTimes;

    public transitsBag() {
	centralTimes = new ArrayList<transit>();
    }
    
    public transitsBag(transitsBag source) {
        centralTimes = new ArrayList<transit>();
        append(source);
    }
    
    public void print(File fileOut) {
	PrintWriter outputStr;
	try {
	    outputStr = new PrintWriter(new BufferedWriter(new FileWriter(fileOut)));
		
	    for (int i = 0; i < centralTimes.size(); i++) {
	    	outputStr.println(String.format("%.10f\t%f\t%d", centralTimes.get(i).centralTime, centralTimes.get(i).sigma, centralTimes.get(i).flag));
	    }
	
	    outputStr.flush();
	} catch (IOException ex) {
		ex.printStackTrace();
	}
	
    }
    
    public void remove(int i) {
	centralTimes.remove(i);
    }
    
    public void append(transitsBag bag) {
        if (bag == null)
            return;
        
	for (int i = 0; i < bag.size(); i++)
	    add(bag.get(i).centralTime, bag.get(i).sigma, bag.get(i).flag);
	sort();
    }

    public void append(transitsBag bag, int flag) {
        if (bag == null)
            return;

        for (int i = 0; i < bag.size(); i++) {
            if (bag.get(i).flag == flag)
                add(bag.get(i).centralTime, bag.get(i).sigma, bag.get(i).flag);
        }
        sort();
    }

    public transitsBag clone() {
        transitsBag c = new transitsBag();
        for (int i = 0; i < size(); i++)
            c.add(get(i).clone());
        return c;
    }
    
    public void addFromFile(File fileIn) {
	clear();
	appendFromFile(fileIn);
    }
    
    public int appendFromFile(File fileIn) {
	System.out.println("Opening " + fileIn.getAbsolutePath());
	int i = 0;
	try {
		BufferedReader in = new BufferedReader(new FileReader(fileIn));
		
		while (in.ready()) {
		    String line = in.readLine().trim();
		    if (line.startsWith("#"))
			continue;
		    
		    String[] tokens = line.split("[\t\\s]+");
		    
		    try {
			if (tokens.length == 1) {
			    //add(Double.valueOf(tokens[0]), getDefaultErrorBar());
			    throw(new Exception("Not enough columns in tds file " + fileIn.getName()));
			}
			else if (tokens.length == 2)
			    add(Double.valueOf(tokens[0]), Double.valueOf(tokens[1]));
			else if (tokens.length == 3) {
			    add(Double.valueOf(tokens[0]), Double.valueOf(tokens[1]), Double.valueOf(tokens[2]).intValue());
			    
			    
			} 
			i++;
		    } catch (NumberFormatException e) {
			e.printStackTrace();
		    }
		}
		
		
	} catch (Exception ex) {
		ex.printStackTrace();
	}
	
	sort();
	
	return i;
    }
    
    public void sort() {
	// ugly bubble sort
	
	int exch = 1;
	while (exch != 0) {
	    exch = 0;
	    for (int i = 1; i < centralTimes.size(); i++) {
		if (centralTimes.get(i-1).centralTime > centralTimes.get(i).centralTime) {
		    transit t1 = centralTimes.get(i-1).clone();
		    
		    centralTimes.set(i-1, centralTimes.get(i));
		    centralTimes.set(i, t1);
		    exch++;
		}
	    }
	};
    }
    
    public void clear() {
	centralTimes.clear();
	
    }
    
    public double containsTransit(double tinf, double tsup) {
	
	for (int i = 0; i < centralTimes.size(); i++)
	    if ((centralTimes.get(i).centralTime >= tinf) && (centralTimes.get(i).centralTime <= tsup))
		return centralTimes.get(i).centralTime;
	return -1;
    }
    
    public double minCentralTime() {
	
	double ret = centralTimes.get(0).centralTime;
	
	for (int i = 0; i < centralTimes.size(); i++)
	    ret = Math.min(centralTimes.get(i).centralTime, ret);
	return ret;
    }
    
    public double maxCentralTime() {
	double ret = centralTimes.get(0).centralTime;
	for (int i = 0; i < centralTimes.size(); i++)
	    ret = Math.max(centralTimes.get(i).centralTime, ret);
	return ret;
    }
    
    public void add(transit tr) {
	add(tr.centralTime, tr.sigma, tr.flag);
    }
    
    public void add(double time, double sigma) {
	centralTimes.add(new transit(time, sigma));
    }
    
    public void add(double time, double sigma, int flag) {
	centralTimes.add(new transit(time, sigma, flag));
    }
    
    public int size() {
	return centralTimes.size();
    }
    
    public transit get(int i) {
	return centralTimes.get(i);
    }
    
    public transit getAtTime(double JD) {
	
	for (int j = 0; j < centralTimes.size(); j++)
	    if (centralTimes.get(j).centralTime == JD)
		return centralTimes.get(j);
	return null;
    }
    
    public int getIdxAtTime(double JD) {
	
	for (int j = 0; j < centralTimes.size(); j++)
	    if (centralTimes.get(j).centralTime == JD)
		return j;
	return -1;
    }

    public int getClosest(double JD) {
	double min = 1e10;
	int ret = -1;
	
	for (int j = 0; j < centralTimes.size(); j++) {
	    double diff = Math.abs(JD - centralTimes.get(j).centralTime);

	    if (diff < min) {
		min = diff;
		ret = j;
	    }
	}
	
	return ret;
    }
    
    public int getClosest(double JD, int flag) {
	double min = 1e10;
	int ret = -1;
	
	for (int j = 0; j < centralTimes.size(); j++) {
	    double diff = Math.abs(JD - centralTimes.get(j).centralTime);

	    if ((diff < min) && (centralTimes.get(j).flag == flag)) {
		min = diff;
		ret = j;
	    }
	}
	
	return ret;
    }

	public transit getClosest(transit tr) {
		int ret = getClosest(tr.centralTime, tr.flag);
		if (ret == -1)
			return null;
		else
			return get(ret);
	}
    
    public double[][] toArray() {
	
	double[][] ret = new double[centralTimes.size()][3];
	
        for (int i = 0; i < centralTimes.size(); i++) {
            ret[i][0] = centralTimes.get(i).centralTime;
            ret[i][1] = centralTimes.get(i).sigma;
            ret[i][2] = (double) centralTimes.get(i).flag;
        }
	return ret;
    }

    public double[][] toPlotArray() {

	double[][] ret = new double[centralTimes.size()][3];

        for (int i = 0; i < centralTimes.size(); i++) {
            ret[i][0] = centralTimes.get(i).centralTime;
        }
	return ret;
    }
    
    public transitsBag slice(double time1, double time2) {
	transitsBag bag = new transitsBag();

	for (int i = 0; i < size(); i++)
	    if ((get(i).centralTime <= time2) && (get(i).centralTime >= time1))
		bag.add(get(i));

	return bag;
    }

    public transitsBag slice(int flag) {
	transitsBag bag = new transitsBag();

	for (int i = 0; i < size(); i++)
	    if (get(i).flag == flag)
		bag.add(get(i));

	return bag;
    }

    public transitsBag slice(int idx1, int idx2) {
	transitsBag bag = new transitsBag();
	for (int i = idx1; i < idx2; i++)
	    bag.add(get(i));
	return bag;
    }

    public double[] column(int c) {
        double[] ret = new double[size()];

        for (int i = 0; i < ret.length; i++) {
            if (c == 0)
                ret[i] = get(i).centralTime;
            else if (c == 1)
                ret[i] = get(i).sigma;
            else if (c == -1)
                ret[i] = (double) i;
        }
        return ret;
    }
   // static public double getDefaultErrorBar() {
	//return 0.01;
    //}
    
}
