/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package utils;

import java.io.*;
import java.util.*;
import java.util.regex.*;
import repl.*;

/**
 *
 * @author stefano
 */
public class SystemicData {
    public Double Mstar = null;
    public Double epoch = null;
    public String[] data;
    public Map<String, Integer> dataType = new HashMap<String, Integer>();
    public String name;
    
    public static Pattern rvPattern = Pattern.compile("RV\\[\\] \"(.*?)\"");
    public static Pattern ttvPattern = Pattern.compile("TD\\[\\] \"(.*?)\"");
    public static Pattern massPattern = Pattern.compile("Mass (.*)");
    public static Pattern epochPattern = Pattern.compile("Epoch (.*)");
    public static Pattern namePattern = Pattern.compile("\"(.*?)\" \\{");
    
    public static SystemicData readFromFile(String path) throws FileNotFoundException, IOException {
        return SystemicData.readFromFile(path, "datafiles/");
    }
            
    public static SystemicData readFromFile(String path, String searchPath) throws FileNotFoundException, IOException {
        
        
        SystemicData data = new SystemicData();
        
        ArrayList<String> datafns = new ArrayList<String>();
        
        
        ArrayList<String> lines = FileUtils.readFile(path);
        
        for (String line: lines) {
            
            if (rvPattern.matcher(line).find()) {
                
                Matcher m = rvPattern.matcher(line);
                m.find();
                String rvPath = m.group(1);
                if (! new File(rvPath).exists())
                    rvPath = new File(".").toURI().relativize(new File(searchPath, rvPath).toURI()).getPath();
                datafns.add(rvPath);
                data.dataType.put(rvPath, Defs.T_RV);
            } else if (ttvPattern.matcher(line).find()) {
                
                Matcher m = ttvPattern.matcher(line);
                m.find();
                String ttvPath = m.group(1);
                if (! new File(ttvPath).exists())
                    ttvPath = new File(".").toURI().relativize(new File(searchPath, ttvPath).toURI()).getPath();
                datafns.add(ttvPath);
                data.dataType.put(ttvPath, Defs.T_TIMING);
            } else if (massPattern.matcher(line).find()) {
                Matcher m = massPattern.matcher(line);
                m.find();
                
                String mass = m.group(1);
                data.Mstar = Double.valueOf(mass);
            } else if (epochPattern.matcher(line).find()) {
                Matcher m = epochPattern.matcher(line);
                m.find();
                
                String epoch = m.group(1);
                data.epoch = Double.valueOf(epoch);
            } else if (namePattern.matcher(line).find()) {
                Matcher m = namePattern.matcher(line);
                m.find();
                data.name = m.group(1);
            }
        }
        
        data.data = datafns.toArray(new String[0]);
        
        return data;
    }
}
