ffi = require 'ffi'
gsl = {}
lib = {}

require 'defs'

-- C
ffi.cdef[[
	typedef void FILE;
	FILE* stdout;
]]

-- matrix and vector
ffi.cdef[[
	typedef struct {
		size_t size1;
		size_t size2;
		size_t tda;
		double* data;
		void* block;
		int owner;
	} gsl_matrix;
]]

ffi.metatype("gsl_matrix", {
	__call = function(m, i, j)
		return m.data[i * m.size2 + j]
	end
})


ffi.cdef[[
typedef void ok_kernel;

ok_kernel* K_alloc();
gsl_matrix* K_addRVFile(ok_kernel* k, const char* path);
gsl_matrix* K_getElements(ok_kernel* k);
double K_getChi2(ok_kernel* k);
void K_calculate(ok_kernel* k);
void K_setElement(ok_kernel* k, int idx, int col, double val);
double K_getElement(ok_kernel* k, int idx, int col);
void K_setPar(ok_kernel* k, int idx, double val);
double K_getPar(ok_kernel* k, int idx);

void K_addPlanet(ok_kernel* k, const double elements[]);
void K_print(ok_kernel* k, FILE* f);
]]



sys = ffi.load("../systemic.dylib")